version 11.2

*adjust working directory!

use replication.dta, clear

*create two party system dummy
gen two_party_system = 0
replace two_party_system = 1 if efs <2.5

xtset party year
xtreg chrile  incl chpmean ichpmean chcmean ichcmean lchrile if two_party_system==1, fe robust
matrix v = e(V)
drop _all
set obs 4
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}
gen type = "fe_1"
save figure3_fe_1.dta, replace

use replication, clear

gen two_party_system = 0
replace two_party_system = 1 if efs <2.5

xtreg chrile  incl chpmean ichpmean chcmean ichcmean lchrile if two_party_system==0, fe robust
matrix v = e(V)
drop _all
set obs 4
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}

gen type = "fe_0"
save figure3_fe_0.dta, replace

use replication.dta, clear

gen two_party_system = 0
replace two_party_system = 1 if efs <2.5

xtset party year
xtgls chrile incl chpmean ichpmean chcmean ichcmean i.party if two_party_system==0, panels(heteroscedastic) corr(ar) noconstant force
matrix v = e(V)
drop _all
set obs 4
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}
gen type = "gls_1"
save figure3_gls_1.dta, replace

use replication, clear

gen two_party_system = 0
replace two_party_system = 1 if efs <2.5


xtgls chrile incl chpmean ichpmean chcmean ichcmean i.party if two_party_system==0, panels(heteroscedastic) corr(ar) noconstant force
matrix v = e(V)
drop _all
set obs 4
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}

gen type = "gls_0"

append using  figure3_gls_1.dta
append using  figure3_fe_0.dta
append using  figure3_fe_1.dta

replace n = n + 0.2 if type =="fe_0"|type=="fe_1"

preserve
keep if type =="fe_0"|type=="gls_0"

#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(pmean_3_0, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	l1title(Multy-Party Model)
	;
#delimit cr;
restore

preserve
keep if type=="fe_0"|type=="gls_0"
drop if n <3
replace n = n -2


#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(cmean_3_0, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	
	;
#delimit cr;
restore

preserve
keep if type =="fe_1"|type=="gls_1"

#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(pmean_3_1, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	title(Shift Mean Supporter, color(black)) 
	l1title(Two-Party Model)
	;
#delimit cr;
restore

preserve
keep if type=="fe_1"|type=="gls_1"
drop if n <3
replace n = n -2


#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(cmean_3_1, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	title(Shift Mean Voter, color(black))

	;
#delimit cr;
restore

#delimit ;
graph combine pmean_3_1.gph cmean_3_1.gph pmean_3_0.gph cmean_3_0.gph,
commonscheme
cols(2)
graphregion(color(white))
plotregion(color(white))
l1title(Marginal Effect on Change in Party Position)
saving(figure2.gph, replace)
b2title(Inclusiveness)
ycommon
xcommon
;
#delimit cr;

erase figure3_gls_1.dta
erase figure3_fe_0.dta
erase figure3_fe_1.dta

erase pmean_3_0.gph
erase cmean_3_0.gph
erase pmean_3_1.gph
erase cmean_3_1.gph
